/* Settings.c generated by valac 0.39.92, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
* Copyright (c) 2012-2017 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Corentin Noël <corentin@elementary.io>
*/


#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>


#define APP_CENTER_TYPE_SETTINGS (app_center_settings_get_type ())
#define APP_CENTER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettings))
#define APP_CENTER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))
#define APP_CENTER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_TYPE_SETTINGS))
#define APP_CENTER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsClass))

typedef struct _AppCenterSettings AppCenterSettings;
typedef struct _AppCenterSettingsClass AppCenterSettingsClass;
typedef struct _AppCenterSettingsPrivate AppCenterSettingsPrivate;

#define APP_CENTER_SETTINGS_TYPE_WINDOW_STATE (app_center_settings_window_state_get_type ())
enum  {
	APP_CENTER_SETTINGS_0_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY,
	APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY,
	APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY,
	APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY,
	APP_CENTER_SETTINGS_PAID_APPS_PROPERTY,
	APP_CENTER_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* app_center_settings_properties[APP_CENTER_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AppCenterSettings {
	GraniteServicesSettings parent_instance;
	AppCenterSettingsPrivate * priv;
};

struct _AppCenterSettingsClass {
	GraniteServicesSettingsClass parent_class;
};

typedef enum  {
	APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL,
	APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED,
	APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN
} AppCenterSettingsWindowState;

struct _AppCenterSettingsPrivate {
	gint _window_width;
	gint _window_height;
	AppCenterSettingsWindowState _window_state;
	gboolean _developer_mode;
	gboolean _reset_paid_apps;
	gchar** _paid_apps;
	gint _paid_apps_length1;
	gint __paid_apps_size_;
};


static gpointer app_center_settings_parent_class = NULL;
static AppCenterSettings* app_center_settings_main_settings;
static AppCenterSettings* app_center_settings_main_settings = NULL;

GType app_center_settings_get_type (void) G_GNUC_CONST;
GType app_center_settings_window_state_get_type (void) G_GNUC_CONST;
#define APP_CENTER_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), APP_CENTER_TYPE_SETTINGS, AppCenterSettingsPrivate))
AppCenterSettings* app_center_settings_get_default (void);
static AppCenterSettings* app_center_settings_new (void);
static AppCenterSettings* app_center_settings_construct (GType object_type);
void app_center_settings_add_paid_app (AppCenterSettings* self,
                                       const gchar* id);
gchar** app_center_settings_get_paid_apps (AppCenterSettings* self,
                                           int* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      gchar* needle);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
static void _vala_array_add14 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void app_center_settings_set_paid_apps (AppCenterSettings* self,
                                        gchar** value,
                                        int value_length1);
gint app_center_settings_get_window_width (AppCenterSettings* self);
void app_center_settings_set_window_width (AppCenterSettings* self,
                                           gint value);
gint app_center_settings_get_window_height (AppCenterSettings* self);
void app_center_settings_set_window_height (AppCenterSettings* self,
                                            gint value);
AppCenterSettingsWindowState app_center_settings_get_window_state (AppCenterSettings* self);
void app_center_settings_set_window_state (AppCenterSettings* self,
                                           AppCenterSettingsWindowState value);
gboolean app_center_settings_get_developer_mode (AppCenterSettings* self);
void app_center_settings_set_developer_mode (AppCenterSettings* self,
                                             gboolean value);
gboolean app_center_settings_get_reset_paid_apps (AppCenterSettings* self);
void app_center_settings_set_reset_paid_apps (AppCenterSettings* self,
                                              gboolean value);
static gchar** _vala_array_dup5 (gchar** self,
                          int length);
static void app_center_settings_finalize (GObject * obj);
static void _vala_app_center_settings_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_app_center_settings_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GType
app_center_settings_window_state_get_type (void)
{
	static volatile gsize app_center_settings_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_window_state_type_id__volatile)) {
		static const GEnumValue values[] = {{APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL, "APP_CENTER_SETTINGS_WINDOW_STATE_NORMAL", "normal"}, {APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED, "APP_CENTER_SETTINGS_WINDOW_STATE_MAXIMIZED", "maximized"}, {APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN, "APP_CENTER_SETTINGS_WINDOW_STATE_FULLSCREEN", "fullscreen"}, {0, NULL, NULL}};
		GType app_center_settings_window_state_type_id;
		app_center_settings_window_state_type_id = g_enum_register_static ("AppCenterSettingsWindowState", values);
		g_once_init_leave (&app_center_settings_window_state_type_id__volatile, app_center_settings_window_state_type_id);
	}
	return app_center_settings_window_state_type_id__volatile;
}


AppCenterSettings*
app_center_settings_get_default (void)
{
	AppCenterSettings* result = NULL;
	AppCenterSettings* _tmp0_;
	AppCenterSettings* _tmp2_;
#line 39 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = app_center_settings_main_settings;
#line 39 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (_tmp0_ == NULL) {
#line 171 "Settings.c"
		AppCenterSettings* _tmp1_;
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp1_ = app_center_settings_new ();
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_g_object_unref0 (app_center_settings_main_settings);
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_main_settings = _tmp1_;
#line 179 "Settings.c"
	}
#line 41 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp2_ = app_center_settings_main_settings;
#line 41 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp2_;
#line 41 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 187 "Settings.c"
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             gchar* needle)
{
	int i;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	for (i = 0; i < stack_length; i++) {
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
			return TRUE;
#line 203 "Settings.c"
		}
	}
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return FALSE;
#line 208 "Settings.c"
}


static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = g_new0 (gchar*, length + 1);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	for (i = 0; i < length; i++) {
#line 222 "Settings.c"
		gchar* _tmp0_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp0_ = g_strdup (self[i]);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		result[i] = _tmp0_;
#line 228 "Settings.c"
	}
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 232 "Settings.c"
}


static void
_vala_array_add14 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if ((*length) == (*size)) {
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 248 "Settings.c"
	}
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	(*array)[(*length)++] = value;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	(*array)[*length] = NULL;
#line 254 "Settings.c"
}


void
app_center_settings_add_paid_app (AppCenterSettings* self,
                                  const gchar* id)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 44 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (id != NULL);
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = app_center_settings_get_paid_apps (self, &_tmp0__length1);
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp1_ = _tmp0_;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (!_vala_string_array_contains (_tmp1_, _tmp1__length1, id)) {
#line 278 "Settings.c"
		gchar** apps_copy = NULL;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gint apps_copy_length1;
		gint _apps_copy_size_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp2_ = app_center_settings_get_paid_apps (self, &_tmp2__length1);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp3_ = _tmp2_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp3__length1 = _tmp2__length1;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup4 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp4__length1 = _tmp3__length1;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		apps_copy = _tmp4_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		apps_copy_length1 = _tmp4__length1;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_apps_copy_size_ = apps_copy_length1;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp5_ = apps_copy;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp5__length1 = apps_copy_length1;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp6_ = g_strdup (id);
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_vala_array_add14 (&apps_copy, &apps_copy_length1, &_apps_copy_size_, _tmp6_);
#line 48 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp7_ = apps_copy;
#line 48 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp7__length1 = apps_copy_length1;
#line 48 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_paid_apps (self, _tmp7_, _tmp7__length1);
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		apps_copy = (_vala_array_free (apps_copy, apps_copy_length1, (GDestroyNotify) g_free), NULL);
#line 325 "Settings.c"
	}
}


static AppCenterSettings*
app_center_settings_construct (GType object_type)
{
	AppCenterSettings * self = NULL;
#line 53 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	self = (AppCenterSettings*) granite_services_settings_construct (object_type, "io.elementary.appcenter.settings");
#line 52 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return self;
#line 338 "Settings.c"
}


static AppCenterSettings*
app_center_settings_new (void)
{
#line 52 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return app_center_settings_construct (APP_CENTER_TYPE_SETTINGS);
#line 347 "Settings.c"
}


gint
app_center_settings_get_window_width (AppCenterSettings* self)
{
	gint result;
	gint _tmp0_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_window_width;
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 364 "Settings.c"
}


void
app_center_settings_set_window_width (AppCenterSettings* self,
                                      gint value)
{
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_window_width (self) != value) {
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_window_width = value;
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY]);
#line 380 "Settings.c"
	}
}


gint
app_center_settings_get_window_height (AppCenterSettings* self)
{
	gint result;
	gint _tmp0_;
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_window_height;
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 398 "Settings.c"
}


void
app_center_settings_set_window_height (AppCenterSettings* self,
                                       gint value)
{
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_window_height (self) != value) {
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_window_height = value;
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY]);
#line 414 "Settings.c"
	}
}


AppCenterSettingsWindowState
app_center_settings_get_window_state (AppCenterSettings* self)
{
	AppCenterSettingsWindowState result;
	AppCenterSettingsWindowState _tmp0_;
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_window_state;
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 432 "Settings.c"
}


void
app_center_settings_set_window_state (AppCenterSettings* self,
                                      AppCenterSettingsWindowState value)
{
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_window_state (self) != value) {
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_window_state = value;
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY]);
#line 448 "Settings.c"
	}
}


gboolean
app_center_settings_get_developer_mode (AppCenterSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_developer_mode;
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 466 "Settings.c"
}


void
app_center_settings_set_developer_mode (AppCenterSettings* self,
                                        gboolean value)
{
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_developer_mode (self) != value) {
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_developer_mode = value;
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY]);
#line 482 "Settings.c"
	}
}


gboolean
app_center_settings_get_reset_paid_apps (AppCenterSettings* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_reset_paid_apps;
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 500 "Settings.c"
}


void
app_center_settings_set_reset_paid_apps (AppCenterSettings* self,
                                         gboolean value)
{
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_reset_paid_apps (self) != value) {
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_reset_paid_apps = value;
#line 34 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY]);
#line 516 "Settings.c"
	}
}


gchar**
app_center_settings_get_paid_apps (AppCenterSettings* self,
                                   int* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0_ = self->priv->_paid_apps;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp0__length1 = self->priv->_paid_apps_length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp1_ = _tmp0_;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (result_length1) {
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		*result_length1 = _tmp1__length1;
#line 544 "Settings.c"
	}
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = _tmp1_;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 550 "Settings.c"
}


static gchar**
_vala_array_dup5 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	result = g_new0 (gchar*, length + 1);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	for (i = 0; i < length; i++) {
#line 564 "Settings.c"
		gchar* _tmp0_;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp0_ = g_strdup (self[i]);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		result[i] = _tmp0_;
#line 570 "Settings.c"
	}
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	return result;
#line 574 "Settings.c"
}


void
app_center_settings_set_paid_apps (AppCenterSettings* self,
                                   gchar** value,
                                   int value_length1)
{
	int old_value_length;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	if (app_center_settings_get_paid_apps (self, &old_value_length) != value) {
#line 588 "Settings.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : ((gpointer) value);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		_tmp0__length1 = value_length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_paid_apps = (_vala_array_free (self->priv->_paid_apps, self->priv->_paid_apps_length1, (GDestroyNotify) g_free), NULL);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_paid_apps = _tmp0_;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->_paid_apps_length1 = _tmp0__length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		self->priv->__paid_apps_size_ = self->priv->_paid_apps_length1;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, app_center_settings_properties[APP_CENTER_SETTINGS_PAID_APPS_PROPERTY]);
#line 605 "Settings.c"
	}
}


static void
app_center_settings_class_init (AppCenterSettingsClass * klass)
{
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	app_center_settings_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_type_class_add_private (klass, sizeof (AppCenterSettingsPrivate));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_center_settings_get_property;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_center_settings_set_property;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = app_center_settings_finalize;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY] = g_param_spec_enum ("window-state", "window-state", "window-state", APP_CENTER_SETTINGS_TYPE_WINDOW_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY] = g_param_spec_boolean ("developer-mode", "developer-mode", "developer-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY] = g_param_spec_boolean ("reset-paid-apps", "reset-paid-apps", "reset-paid-apps", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_CENTER_SETTINGS_PAID_APPS_PROPERTY, app_center_settings_properties[APP_CENTER_SETTINGS_PAID_APPS_PROPERTY] = g_param_spec_boxed ("paid-apps", "paid-apps", "paid-apps", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 635 "Settings.c"
}


static void
app_center_settings_instance_init (AppCenterSettings * self)
{
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	self->priv = APP_CENTER_SETTINGS_GET_PRIVATE (self);
#line 644 "Settings.c"
}


static void
app_center_settings_finalize (GObject * obj)
{
	AppCenterSettings * self;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	self->priv->_paid_apps = (_vala_array_free (self->priv->_paid_apps, self->priv->_paid_apps_length1, (GDestroyNotify) g_free), NULL);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	G_OBJECT_CLASS (app_center_settings_parent_class)->finalize (obj);
#line 658 "Settings.c"
}


GType
app_center_settings_get_type (void)
{
	static volatile gsize app_center_settings_type_id__volatile = 0;
	if (g_once_init_enter (&app_center_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppCenterSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppCenterSettings), 0, (GInstanceInitFunc) app_center_settings_instance_init, NULL };
		GType app_center_settings_type_id;
		app_center_settings_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "AppCenterSettings", &g_define_type_info, 0);
		g_once_init_leave (&app_center_settings_type_id__volatile, app_center_settings_type_id);
	}
	return app_center_settings_type_id__volatile;
}


static void
_vala_app_center_settings_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_value_set_int (value, app_center_settings_get_window_width (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_value_set_int (value, app_center_settings_get_window_height (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_value_set_enum (value, app_center_settings_get_window_state (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_value_set_boolean (value, app_center_settings_get_developer_mode (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		g_value_set_boolean (value, app_center_settings_get_reset_paid_apps (self));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_PAID_APPS_PROPERTY:
#line 718 "Settings.c"
		{
			int length;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
			g_value_set_boxed (value, app_center_settings_get_paid_apps (self, &length));
#line 723 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 727 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 733 "Settings.c"
	}
}


static void
_vala_app_center_settings_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	AppCenterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APP_CENTER_TYPE_SETTINGS, AppCenterSettings);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_WIDTH_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_window_width (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_HEIGHT_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_window_height (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_WINDOW_STATE_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_window_state (self, g_value_get_enum (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_DEVELOPER_MODE_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_developer_mode (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_RESET_PAID_APPS_PROPERTY:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		app_center_settings_set_reset_paid_apps (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		case APP_CENTER_SETTINGS_PAID_APPS_PROPERTY:
#line 780 "Settings.c"
		{
			gpointer boxed;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
			boxed = g_value_get_boxed (value);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
			app_center_settings_set_paid_apps (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 787 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 791 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/Settings.vala"
		break;
#line 797 "Settings.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



