/* SuspendControl.c generated by valac 0.39.92, the Vala compiler
 * generated from SuspendControl.vala, do not modify */

/*
* Copyright (c) 2011-2015 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Richard Fairthorne <richard.fairthorne@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SESSION_MANAGER (session_manager_get_type ())
#define SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SESSION_MANAGER, SessionManager))
#define IS_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SESSION_MANAGER))
#define SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SESSION_MANAGER, SessionManagerIface))

typedef struct _SessionManager SessionManager;
typedef struct _SessionManagerIface SessionManagerIface;

#define TYPE_SESSION_MANAGER_PROXY (session_manager_proxy_get_type ())
typedef GDBusProxy SessionManagerProxy;
typedef GDBusProxyClass SessionManagerProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUSPEND_CONTROL (suspend_control_get_type ())
#define SUSPEND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUSPEND_CONTROL, SuspendControl))
#define SUSPEND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUSPEND_CONTROL, SuspendControlClass))
#define IS_SUSPEND_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUSPEND_CONTROL))
#define IS_SUSPEND_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUSPEND_CONTROL))
#define SUSPEND_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUSPEND_CONTROL, SuspendControlClass))

typedef struct _SuspendControl SuspendControl;
typedef struct _SuspendControlClass SuspendControlClass;
typedef struct _SuspendControlPrivate SuspendControlPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecSuspendControl ParamSpecSuspendControl;

struct _SessionManagerIface {
	GTypeInterface parent_iface;
	guint32 (*inhibit) (SessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error);
	void (*uninhibit) (SessionManager* self, guint32 inhibit_cookie, GError** error);
};

struct _SuspendControl {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SuspendControlPrivate * priv;
};

struct _SuspendControlClass {
	GTypeClass parent_class;
	void (*finalize) (SuspendControl *self);
};

struct _SuspendControlPrivate {
	SessionManager* sm;
	gboolean inhibited;
	guint32 inhibit_cookie;
	gboolean supported;
};

struct _ParamSpecSuspendControl {
	GParamSpec parent_instance;
};


static gpointer suspend_control_parent_class = NULL;

GType session_manager_proxy_get_type (void) G_GNUC_CONST;
guint session_manager_register_object (void* object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error);
GType session_manager_get_type (void) G_GNUC_CONST;
guint32 session_manager_inhibit (SessionManager* self,
                                 const gchar* app_id,
                                 guint32 toplevel_xid,
                                 const gchar* reason,
                                 guint32 flags,
                                 GError** error);
void session_manager_uninhibit (SessionManager* self,
                                guint32 inhibit_cookie,
                                GError** error);
static void session_manager_proxy_g_signal (GDBusProxy* proxy,
                                     const gchar* sender_name,
                                     const gchar* signal_name,
                                     GVariant* parameters);
static guint32 session_manager_proxy_inhibit (SessionManager* self,
                                       const gchar* app_id,
                                       guint32 toplevel_xid,
                                       const gchar* reason,
                                       guint32 flags,
                                       GError** error);
static void session_manager_proxy_uninhibit (SessionManager* self,
                                      guint32 inhibit_cookie,
                                      GError** error);
static void session_manager_proxy_session_manager_interface_init (SessionManagerIface* iface);
static void _dbus_session_manager_inhibit (SessionManager* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_session_manager_uninhibit (SessionManager* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation);
static void session_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data);
static GVariant* session_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GError** error,
                                                       gpointer user_data);
static gboolean session_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data);
static void _session_manager_unregister_object (gpointer user_data);
gpointer suspend_control_ref (gpointer instance);
void suspend_control_unref (gpointer instance);
GParamSpec* param_spec_suspend_control (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_suspend_control (GValue* value,
                                gpointer v_object);
void value_take_suspend_control (GValue* value,
                                 gpointer v_object);
gpointer value_get_suspend_control (const GValue* value);
GType suspend_control_get_type (void) G_GNUC_CONST;
#define SUSPEND_CONTROL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SUSPEND_CONTROL, SuspendControlPrivate))
SuspendControl* suspend_control_new (void);
SuspendControl* suspend_control_construct (GType object_type);
gboolean suspend_control_inhibit (SuspendControl* self);
gboolean suspend_control_uninhibit (SuspendControl* self);
static void suspend_control_finalize (SuspendControl * obj);

static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_app_id = {-1, "app_id", "s"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_toplevel_xid = {-1, "toplevel_xid", "u"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_reason = {-1, "reason", "s"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_flags = {-1, "flags", "u"};
static const GDBusArgInfo _session_manager_dbus_arg_info_inhibit_result = {-1, "result", "u"};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_inhibit_in[] = {&_session_manager_dbus_arg_info_inhibit_app_id, &_session_manager_dbus_arg_info_inhibit_toplevel_xid, &_session_manager_dbus_arg_info_inhibit_reason, &_session_manager_dbus_arg_info_inhibit_flags, NULL};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_inhibit_out[] = {&_session_manager_dbus_arg_info_inhibit_result, NULL};
static const GDBusMethodInfo _session_manager_dbus_method_info_inhibit = {-1, "Inhibit", (GDBusArgInfo **) (&_session_manager_dbus_arg_info_inhibit_in), (GDBusArgInfo **) (&_session_manager_dbus_arg_info_inhibit_out)};
static const GDBusArgInfo _session_manager_dbus_arg_info_uninhibit_inhibit_cookie = {-1, "inhibit_cookie", "u"};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_uninhibit_in[] = {&_session_manager_dbus_arg_info_uninhibit_inhibit_cookie, NULL};
static const GDBusArgInfo * const _session_manager_dbus_arg_info_uninhibit_out[] = {NULL};
static const GDBusMethodInfo _session_manager_dbus_method_info_uninhibit = {-1, "Uninhibit", (GDBusArgInfo **) (&_session_manager_dbus_arg_info_uninhibit_in), (GDBusArgInfo **) (&_session_manager_dbus_arg_info_uninhibit_out)};
static const GDBusMethodInfo * const _session_manager_dbus_method_info[] = {&_session_manager_dbus_method_info_inhibit, &_session_manager_dbus_method_info_uninhibit, NULL};
static const GDBusSignalInfo * const _session_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _session_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _session_manager_dbus_interface_info = {-1, "org.gnome.SessionManager", (GDBusMethodInfo **) (&_session_manager_dbus_method_info), (GDBusSignalInfo **) (&_session_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_session_manager_dbus_property_info)};
static const GDBusInterfaceVTable _session_manager_dbus_interface_vtable = {session_manager_dbus_interface_method_call, session_manager_dbus_interface_get_property, session_manager_dbus_interface_set_property};

guint32
session_manager_inhibit (SessionManager* self,
                         const gchar* app_id,
                         guint32 toplevel_xid,
                         const gchar* reason,
                         guint32 flags,
                         GError** error)
{
#line 24 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 24 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return SESSION_MANAGER_GET_INTERFACE (self)->inhibit (self, app_id, toplevel_xid, reason, flags, error);
#line 202 "SuspendControl.c"
}


void
session_manager_uninhibit (SessionManager* self,
                           guint32 inhibit_cookie,
                           GError** error)
{
#line 25 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	SESSION_MANAGER_GET_INTERFACE (self)->uninhibit (self, inhibit_cookie, error);
#line 215 "SuspendControl.c"
}


static void
session_manager_base_init (SessionManagerIface * iface)
{
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	static gboolean initialized = FALSE;
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (!initialized) {
#line 23 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		initialized = TRUE;
#line 228 "SuspendControl.c"
	}
}


GType
session_manager_get_type (void)
{
	static volatile gsize session_manager_type_id__volatile = 0;
	if (g_once_init_enter (&session_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SessionManagerIface), (GBaseInitFunc) session_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType session_manager_type_id;
		session_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "SessionManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (session_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) session_manager_proxy_get_type);
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SessionManager");
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_session_manager_dbus_interface_info));
		g_type_set_qdata (session_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) session_manager_register_object);
		g_once_init_leave (&session_manager_type_id__volatile, session_manager_type_id);
	}
	return session_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (SessionManagerProxy, session_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SESSION_MANAGER, session_manager_proxy_session_manager_interface_init) )
static void
session_manager_proxy_class_init (SessionManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = session_manager_proxy_g_signal;
}


static void
session_manager_proxy_g_signal (GDBusProxy* proxy,
                                const gchar* sender_name,
                                const gchar* signal_name,
                                GVariant* parameters)
{
}


static void
session_manager_proxy_init (SessionManagerProxy* self)
{
}


static guint32
session_manager_proxy_inhibit (SessionManager* self,
                               const gchar* app_id,
                               guint32 toplevel_xid,
                               const gchar* reason,
                               guint32 flags,
                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp2_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Inhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (toplevel_xid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (reason));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		guint32 _tmp0_ = 0U;
		return _tmp0_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp1_ = 0U;
		g_object_unref (_reply_message);
		return _tmp1_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp2_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp2_);
	g_variant_unref (_tmp2_);
	g_object_unref (_reply_message);
	return _result;
}


static void
session_manager_proxy_uninhibit (SessionManager* self,
                                 guint32 inhibit_cookie,
                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Uninhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (inhibit_cookie));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void
session_manager_proxy_session_manager_interface_init (SessionManagerIface* iface)
{
	iface->inhibit = session_manager_proxy_inhibit;
	iface->uninhibit = session_manager_proxy_uninhibit;
}


static void
_dbus_session_manager_inhibit (SessionManager* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* app_id = NULL;
	GVariant* _tmp3_;
	guint32 toplevel_xid = 0U;
	GVariant* _tmp4_;
	gchar* reason = NULL;
	GVariant* _tmp5_;
	guint32 flags = 0U;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	app_id = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	toplevel_xid = g_variant_get_uint32 (_tmp4_);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_dup_string (_tmp5_, NULL);
	g_variant_unref (_tmp5_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp6_);
	g_variant_unref (_tmp6_);
	result = session_manager_inhibit (self, app_id, toplevel_xid, reason, flags, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (app_id);
	_g_free0 (reason);
}


static void
_dbus_session_manager_uninhibit (SessionManager* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 inhibit_cookie = 0U;
	GVariant* _tmp7_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	inhibit_cookie = g_variant_get_uint32 (_tmp7_);
	g_variant_unref (_tmp7_);
	session_manager_uninhibit (self, inhibit_cookie, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void
session_manager_dbus_interface_method_call (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* method_name,
                                            GVariant* parameters,
                                            GDBusMethodInvocation* invocation,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Inhibit") == 0) {
		_dbus_session_manager_inhibit (object, parameters, invocation);
	} else if (strcmp (method_name, "Uninhibit") == 0) {
		_dbus_session_manager_uninhibit (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant*
session_manager_dbus_interface_get_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean
session_manager_dbus_interface_set_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GVariant* value,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint
session_manager_register_object (gpointer object,
                                 GDBusConnection* connection,
                                 const gchar* path,
                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_session_manager_dbus_interface_info), &_session_manager_dbus_interface_vtable, data, _session_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void
_session_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


SuspendControl*
suspend_control_construct (GType object_type)
{
	SuspendControl* self = NULL;
	GError * _inner_error_ = NULL;
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self = (SuspendControl*) g_type_create_instance (object_type);
#line 536 "SuspendControl.c"
	{
		SessionManager* _tmp0_ = NULL;
		SessionManager* _tmp1_;
		SessionManager* _tmp2_;
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp1_ = g_initable_new (TYPE_SESSION_MANAGER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.SessionManager", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SessionManager", "g-interface-name", "org.gnome.SessionManager", "g-interface-info", g_type_get_qdata (TYPE_SESSION_MANAGER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp0_ = (SessionManager*) _tmp1_;
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 549 "SuspendControl.c"
				goto __catch25_g_io_error;
			}
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			g_clear_error (&_inner_error_);
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			return NULL;
#line 558 "SuspendControl.c"
		}
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp2_ = _tmp0_;
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp0_ = NULL;
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_g_object_unref0 (self->priv->sm);
#line 37 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		self->priv->sm = _tmp2_;
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_g_object_unref0 (_tmp0_);
#line 570 "SuspendControl.c"
	}
	goto __finally25;
	__catch25_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		e = _inner_error_;
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_inner_error_ = NULL;
#line 39 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		self->priv->supported = FALSE;
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp3_ = e;
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp4_ = _tmp3_->message;
#line 40 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_critical ("SuspendControl.vala:40: %s", _tmp4_);
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_g_error_free0 (e);
#line 592 "SuspendControl.c"
	}
	__finally25:
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_clear_error (&_inner_error_);
#line 36 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		return NULL;
#line 603 "SuspendControl.c"
	}
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return self;
#line 607 "SuspendControl.c"
}


SuspendControl*
suspend_control_new (void)
{
#line 35 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return suspend_control_construct (TYPE_SUSPEND_CONTROL);
#line 616 "SuspendControl.c"
}


gboolean
suspend_control_inhibit (SuspendControl* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	_tmp1_ = self->priv->inhibited;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (_tmp1_ == FALSE) {
#line 634 "SuspendControl.c"
		gboolean _tmp2_;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp2_ = self->priv->supported;
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp0_ = _tmp2_;
#line 640 "SuspendControl.c"
	} else {
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp0_ = FALSE;
#line 644 "SuspendControl.c"
	}
#line 45 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (_tmp0_) {
#line 648 "SuspendControl.c"
		{
			guint32 _tmp3_ = 0U;
			SessionManager* _tmp4_;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp4_ = self->priv->sm;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp3_ = session_manager_inhibit (_tmp4_, "org.richardfairthorne.SuspendControl", (guint32) 0, "Inhibit suspend during update", (guint32) 4, &_inner_error_);
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 658 "SuspendControl.c"
				gboolean _tmp5_ = FALSE;
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				if (_inner_error_->domain == G_IO_ERROR) {
#line 662 "SuspendControl.c"
					goto __catch26_g_io_error;
				}
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				return _tmp5_;
#line 671 "SuspendControl.c"
			}
#line 47 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			self->priv->inhibit_cookie = _tmp3_;
#line 48 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			self->priv->inhibited = TRUE;
#line 677 "SuspendControl.c"
		}
		goto __finally26;
		__catch26_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			e = _inner_error_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_inner_error_ = NULL;
#line 50 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp6_ = e;
#line 50 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp7_ = _tmp6_->message;
#line 50 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			g_critical ("SuspendControl.vala:50: %s", _tmp7_);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_g_error_free0 (e);
#line 697 "SuspendControl.c"
		}
		__finally26:
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 702 "SuspendControl.c"
			gboolean _tmp8_ = FALSE;
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			g_clear_error (&_inner_error_);
#line 46 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			return _tmp8_;
#line 710 "SuspendControl.c"
		}
	}
#line 54 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	_tmp9_ = self->priv->inhibited;
#line 54 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	result = _tmp9_;
#line 54 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return result;
#line 719 "SuspendControl.c"
}


gboolean
suspend_control_uninhibit (SuspendControl* self)
{
	gboolean result = FALSE;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 731 "SuspendControl.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp1_ = self->priv->inhibited;
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		if (_tmp1_ == TRUE) {
#line 739 "SuspendControl.c"
			gboolean _tmp2_;
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp2_ = self->priv->supported;
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp0_ = _tmp2_;
#line 745 "SuspendControl.c"
		} else {
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp0_ = FALSE;
#line 749 "SuspendControl.c"
		}
#line 59 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		if (_tmp0_) {
#line 753 "SuspendControl.c"
			SessionManager* _tmp3_;
			guint32 _tmp4_;
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp3_ = self->priv->sm;
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			_tmp4_ = self->priv->inhibit_cookie;
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			session_manager_uninhibit (_tmp3_, _tmp4_, &_inner_error_);
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 764 "SuspendControl.c"
				gboolean _tmp5_ = FALSE;
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				if (_inner_error_->domain == G_IO_ERROR) {
#line 768 "SuspendControl.c"
					goto __catch27_g_io_error;
				}
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				g_clear_error (&_inner_error_);
#line 60 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
				return _tmp5_;
#line 777 "SuspendControl.c"
			}
#line 61 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			self->priv->inhibited = FALSE;
#line 781 "SuspendControl.c"
		}
	}
	goto __finally27;
	__catch27_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		e = _inner_error_;
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_inner_error_ = NULL;
#line 64 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp6_ = e;
#line 64 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_tmp7_ = _tmp6_->message;
#line 64 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_critical ("SuspendControl.vala:64: %s", _tmp7_);
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		_g_error_free0 (e);
#line 802 "SuspendControl.c"
	}
	__finally27:
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 807 "SuspendControl.c"
		gboolean _tmp8_ = FALSE;
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_clear_error (&_inner_error_);
#line 58 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		return _tmp8_;
#line 815 "SuspendControl.c"
	}
#line 67 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	_tmp9_ = self->priv->inhibited;
#line 67 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	result = !_tmp9_;
#line 67 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return result;
#line 823 "SuspendControl.c"
}


static void
value_suspend_control_init (GValue* value)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	value->data[0].v_pointer = NULL;
#line 832 "SuspendControl.c"
}


static void
value_suspend_control_free_value (GValue* value)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		suspend_control_unref (value->data[0].v_pointer);
#line 843 "SuspendControl.c"
	}
}


static void
value_suspend_control_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		dest_value->data[0].v_pointer = suspend_control_ref (src_value->data[0].v_pointer);
#line 856 "SuspendControl.c"
	} else {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		dest_value->data[0].v_pointer = NULL;
#line 860 "SuspendControl.c"
	}
}


static gpointer
value_suspend_control_peek_pointer (const GValue* value)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return value->data[0].v_pointer;
#line 870 "SuspendControl.c"
}


static gchar*
value_suspend_control_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (collect_values[0].v_pointer) {
#line 882 "SuspendControl.c"
		SuspendControl * object;
		object = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 889 "SuspendControl.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 893 "SuspendControl.c"
		}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = suspend_control_ref (object);
#line 897 "SuspendControl.c"
	} else {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = NULL;
#line 901 "SuspendControl.c"
	}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return NULL;
#line 905 "SuspendControl.c"
}


static gchar*
value_suspend_control_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SuspendControl ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (!object_p) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 921 "SuspendControl.c"
	}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (!value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		*object_p = NULL;
#line 927 "SuspendControl.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		*object_p = value->data[0].v_pointer;
#line 931 "SuspendControl.c"
	} else {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		*object_p = suspend_control_ref (value->data[0].v_pointer);
#line 935 "SuspendControl.c"
	}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return NULL;
#line 939 "SuspendControl.c"
}


GParamSpec*
param_spec_suspend_control (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSuspendControl* spec;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SUSPEND_CONTROL), NULL);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return G_PARAM_SPEC (spec);
#line 959 "SuspendControl.c"
}


gpointer
value_get_suspend_control (const GValue* value)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL), NULL);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return value->data[0].v_pointer;
#line 970 "SuspendControl.c"
}


void
value_set_suspend_control (GValue* value,
                           gpointer v_object)
{
	SuspendControl * old;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SUSPEND_CONTROL));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = v_object;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		suspend_control_ref (value->data[0].v_pointer);
#line 993 "SuspendControl.c"
	} else {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = NULL;
#line 997 "SuspendControl.c"
	}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		suspend_control_unref (old);
#line 1003 "SuspendControl.c"
	}
}


void
value_take_suspend_control (GValue* value,
                            gpointer v_object)
{
	SuspendControl * old;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SUSPEND_CONTROL));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SUSPEND_CONTROL));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = v_object;
#line 1025 "SuspendControl.c"
	} else {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		value->data[0].v_pointer = NULL;
#line 1029 "SuspendControl.c"
	}
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		suspend_control_unref (old);
#line 1035 "SuspendControl.c"
	}
}


static void
suspend_control_class_init (SuspendControlClass * klass)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	suspend_control_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	((SuspendControlClass *) klass)->finalize = suspend_control_finalize;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_type_class_add_private (klass, sizeof (SuspendControlPrivate));
#line 1049 "SuspendControl.c"
}


static void
suspend_control_instance_init (SuspendControl * self)
{
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self->priv = SUSPEND_CONTROL_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self->priv->inhibited = FALSE;
#line 32 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self->priv->inhibit_cookie = (guint32) 0;
#line 33 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self->priv->supported = TRUE;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self->ref_count = 1;
#line 1066 "SuspendControl.c"
}


static void
suspend_control_finalize (SuspendControl * obj)
{
	SuspendControl * self;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUSPEND_CONTROL, SuspendControl);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_signal_handlers_destroy (self);
#line 30 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	_g_object_unref0 (self->priv->sm);
#line 1080 "SuspendControl.c"
}


GType
suspend_control_get_type (void)
{
	static volatile gsize suspend_control_type_id__volatile = 0;
	if (g_once_init_enter (&suspend_control_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_suspend_control_init, value_suspend_control_free_value, value_suspend_control_copy_value, value_suspend_control_peek_pointer, "p", value_suspend_control_collect_value, "p", value_suspend_control_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SuspendControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) suspend_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SuspendControl), 0, (GInstanceInitFunc) suspend_control_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType suspend_control_type_id;
		suspend_control_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SuspendControl", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&suspend_control_type_id__volatile, suspend_control_type_id);
	}
	return suspend_control_type_id__volatile;
}


gpointer
suspend_control_ref (gpointer instance)
{
	SuspendControl * self;
	self = instance;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	return instance;
#line 1109 "SuspendControl.c"
}


void
suspend_control_unref (gpointer instance)
{
	SuspendControl * self;
	self = instance;
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		SUSPEND_CONTROL_GET_CLASS (self)->finalize (self);
#line 28 "/builddir/build/BUILD/appcenter-0.2.9/src/SuspendControl.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1124 "SuspendControl.c"
	}
}



